// This file is for testing purposes only
// It was copied from the server on 10/07/13
// Also adding jquery import to support $ var

var script = document.createElement('script');
script.src = 'http://jqueryjs.googlecode.com/files/jquery-1.2.6.min.js';
script.type = 'text/javascript';
document.getElementsByTagName('head')[0].appendChild(script);

Stage = {
	urlQueue:[],
	lastTimestamp:0,
	cbCount:0,
	playSampleCount:1,
	callbacks:new Object(),
	socialTypes:['profile', 'feed', 'following', 'followers', 'likes', 'bookmarks'],
	openPage:function (qsVals) {
		var c = "backstage";
		if ($.inArray(qsVals["type"], this.socialTypes) != -1) {
			c = "social";
		}
		qsVals["cat"] = c;
		this.act("openPage", qsVals);
	}, 
	openExternalPage:function (qsVals) {
		this.act("openExternalPage", qsVals);
	},
	createStation:function (qsVals, callback) {
		this.act("createStation", qsVals, callback);
	},
	playSample:function (generatorFunction, callback) {
		var fName = 'sampleInfo_' + (this.playSampleCount++);
		window[fName] = generatorFunction;
		this.act("playSample", {'generator': fName}, callback, true);
	},
	playSampleTrack:function (qsVals, callback) {
		this.act("playSampleTrack", qsVals, callback);
	},
	stopSample:function (qsVals, callback) {
		this.act("stopSample", qsVals, callback);
	},
	pause:function (qsVals, callback) {
		this.act("pauseTrack", qsVals, callback);
	},
	play:function (qsVals, callback) {
		this.act("playTrack", qsVals, callback);
	},
	share:function (qsVals, callback) {
		this.act("share", qsVals, callback);
	},
	launchGenrePanel:function (qsVals, callback) {
		this.act("launchGenrePanel", qsVals, callback);
	},
	closeCustomWebViewContainer:function (qsVals, callback) {
		this.act("closeCustomWebViewContainer", qsVals, callback);
	},
	refreshAd:function (qsVals, callback) {
		this.act("refreshAd", qsVals, callback);
	},
	showTextInput:function (qsVals, callback) {
		this.act("showTextInput", qsVals, callback, true);
	},
	analytics:function (qsVals, callback) {
		this.act("analytics", qsVals, callback);
	},
	refreshStationList:function (qsVals, callback) {
		this.act("refreshStationList", qsVals, callback);
	},
	playlistUpdated:function (qsVals, callback) {
		this.act("playlistUpdated", qsVals, callback);
	},
	launchAddSeed:function (qsVals, callback) {
		this.act("launchAddSeed", qsVals, callback);
	},
	goToScreen:function(qsVals, callback) {
		this.act("goToScreen", qsVals, callback);
	},
	openModalPage:function(qsVals, callback) {
		var c = "backstage";
		if ($.inArray(qsVals["type"], this.socialTypes) != -1) {
			c = "social";
		}
		qsVals["cat"] = c;
		this.act("openModalPage", qsVals, callback);
	},
	closeModalPage:function() {
		this.act("closeModalPage", {}, null);
	},
	sendEvent:function(qsVals, callback) {
			this.act("sendEvent", qsVals, callback);
	},
	act:function (action, qsVals, callback, persistCb) {
		var url = "PandoraStage://" + action;
		if (callback) {  // allow callers to omit the callback param if desired
			var cbid = (persistCb) ?
					this.addPersistentCallback(callback) : this.addCallback(callback);
			url += "/";
			url += cbid;
		}
		var sep = "?";
		for (var key in qsVals) {
			url += sep;
			url += encodeURIComponent(key);
			url += "=";
			url += encodeURIComponent(qsVals[key]);
			sep = "&";
		}
		this.urlQueue.push(url);
		this._checkQueue();
	},
	_checkQueue:function () {
		if (Stage.urlQueue.length > 0) {
			var now = new Date().getTime();
			var elapsed = now - Stage.lastTimestamp;
			if (elapsed < 500) {
				setTimeout(Stage._checkQueue, 500 - elapsed);
			} else {
				Stage.lastTimestamp = now;
				var url = Stage.urlQueue.shift();
				if (Stage.getProperty("os") != null) {
					document.location.href = url;
				} else {
					console.log(url);	// non-mobile browser (for testing)
				}
			}
		}
	},
	addCallback:function (callback) {
		var key = "" + (this.cbCount++);
		this.callbacks[key] = callback;
		return key;
	},
	addPersistentCallback:function (callback) {
		var key = "_" + (this.cbCount++);
		this.callbacks[key] = callback;
		return key;
	},
	_methodResponse:function (/*string*/callbackID, /*hash*/response) {
		var callback = this.callbacks[callbackID];
		if (callback && callbackID.indexOf("_") != 0) {
			delete this.callbacks[callbackID];
		}
		if (typeof(callback) == "function" || typeof(callback) == "string") {
			// we need to delay execution a bit to prevent strange (and
			// potentially deadly) interactions with the webview host.
			var _this = this;
			setTimeout(function () {
				_this._callCallback(callback, [response]);
			}, 1);
		}
	},
	_callCallback:function (nameOrFunction, args) {
		if (typeof nameOrFunction == "function") {
			nameOrFunction.apply(this, args);
		} else {
			// we need to support string names for parity with Android
			window[nameOrFunction].apply(this, args);
		}
	},
	mobileComplete:function () {
		if (stageReadyHeld) {
			stageReadyHeld = false;
			$.holdReady(false);
		}
	},
	// Returns -1 if ver1 < ver2, 0 if ver1 = ver2, and 1 if ver1 > ver2
	compareVersion: function(ver1, ver2) {
		var arr1 = ver1 != null ? ver1.split(".") : [0];
		var arr2 = ver2 != null ? ver2.split(".") : [0];
		var maxParts = Math.max(arr1.length, arr2.length);
		for (var i=0; i < maxParts; i++) {
			var i1 = parseInt(arr1[i])||0;
			var i2 = parseInt(arr2[i])||0;
			if (i1 < i2) return -1;
			if (i1 > i2) return 1;
		}
		return 0;
	},
	// These functions will be injected by the native app, but are defined here to prevent JS errors
	// when testing outside of the native apps (i.e. on Chrome desktop)
	supports:function (action) {
		return false;
	},
	getProperty:function (key) {
		return null;
	}
};
$.holdReady(true);
var stageReadyHeld = true;
setTimeout(Stage.mobileComplete, 3000);
